#pragma once

#define DEF_MEMOSEND_LIST_BG_COLOR				/*Color(255, 00, 255, 255)*/Color(255, 255, 255, 255)
#define DEF_MEMOSEND_LIST_BGOUTLINE_COLOR		Color(255, 180, 180, 180)

#define DEF_MEMOSEND_LIST_FONT_NAME				(g_defaultFontFaceName)
#define DEF_MEMOSEND_LIST_FILE_FONT_HEIGHT		(9)
#define DEF_MEMOSEND_LIST_FILE_FONT_COLOR		(CColorConvert::HEX2Color(0x010203))
#define DEF_MEMOSEND_LIST_FILESIZE_COLOR		(CColorConvert::HEX2Color(0x8d9398))
#define DEF_MEMOSEND_LIST_FILE_FONT_STYLE		(FontStyleRegular)
#define DEF_MEMOSEND_LIST_INIT_FONT_HEIGHT		(9)
#define DEF_MEMOSEND_LIST_INIT_FONT_COLOR		(CColorConvert::HEX2Color(0x2da1ea))
#define DEF_MEMOSEND_LIST_INIT_OUTLINE_COLOR	Color(255, 228, 232, 235)

#define DEF_MEMOSEND_LIST_INIT_GAP_X			(1)
#define DEF_MEMOSEND_LIST_ITEM_POS_LEFT_X		(18)
#define DEF_MEMOSEND_LIST_ITEM_POS_RIGHT_X		(15)
#define DEF_MEMOSEND_LIST_FILESIZE_POS_RIGHT_X	(13)
#define DEF_MEMOSEND_LIST_ITEM_POS_TOP_Y		(10)
#define DEF_MEMOSEND_LIST_ITEM_HEIGHT			(22)
#define DEF_MEMOSEND_LIST_IMG_NAME_GAP_X		(5)
#define DEF_MEMOSEND_LIST_SIZE_WIDTH			(60)
#define DEF_MEMOSEND_LIST_SIZE_PROG_GAP_X		(9)
#define DEF_MEMOSEND_LIST_PROG_WIDTH			(100)
#define DEF_MEMOSEND_LIST_PROG_HEIGHT			(7)
#define DEF_MEMOSEND_LIST_PROG_NAME_GAP_X		(15)

#define DEF_MEMOSEND_LIST_SCROLL_SIZE			(20)

#define ID_MEMOSEND_SCROLLBAR					(0xA021)

class SendMemoController;
class CNoteModel;

// CMemoSendAttachList

class CMemoSendAttachList : public CWnd,
	private IGTWASActorEvent,
	private IGTMessengerActorEvent
{
	DECLARE_DYNAMIC(CMemoSendAttachList)

public:
	CMemoSendAttachList();
	virtual ~CMemoSendAttachList();

public:
	typedef enum _memosend_file_status
	{
		EMEMOSEND_READY = 0,
		EMEMOSEND_PAUSE,
		EMEMOSEND_SENDING,
		EMEMOSEND_COMPLETE,
		EMEMOSEND_CANCEL,
		EMEMOSEND_FORWARD
	} EMEMOSEND_FILE_STATUS;

	typedef struct _memosend_file_item
	{
		CRect					rtItem;
		CRect					rtImgFile;
		CString					strName;
		CString					strShowName;
		CSize					szName;
		CRect					rtName;
		CString					strFullPath;
		CString					strProgress;
		CRect					rtProgress;
		ULONGLONG				dwTotalSize;
		ULONGLONG				dwTotalKiloSize;
		ULONGLONG				dwCurSendSize;
		CString					strSize;
		CRect					rtSize;
		CRect					rtImgCancel;
		_memosend_file_status	eStatus;
		BOOL					bCancel;
		BOOL					bHover;
		BOOL					bDown;
		int						serverIndex;

		_memosend_file_item()
		{
			rtItem.SetRectEmpty();
			rtImgFile.SetRectEmpty();

			strName = _T("");
			strShowName = _T("");
            szName.SetSize(0, 0);
			rtName.SetRectEmpty();
			strFullPath = _T("");

			dwTotalSize = 0;
            dwTotalKiloSize = 0;
			dwCurSendSize = 0;
			strProgress = _T("");
			rtProgress.SetRectEmpty();

			strSize = _T("");
			rtSize.SetRectEmpty();

			rtImgCancel.SetRectEmpty();

			eStatus = EMEMOSEND_READY;

			bCancel = TRUE;
			bHover = FALSE;
			bDown = FALSE;
            serverIndex = 0;
		}
	} MEMOSEND_FILE_ITEM, *PMEMOSEND_FILE_ITEM;

	// ÷   ش ͸ .  信  UI  ó.
	typedef struct DELETE_ATTACH_FILE_INFO
	{
		_memosend_file_item		*pFileItemNext;
		_memosend_file_item		*pFileItem;
		int						index;

		void InitData()
		{
			pFileItemNext = NULL;
			pFileItem = NULL;
			index = -1;
		}
	} DELETE_ATTACH_FILE_INFO; 

	// BG
	Image*						m_pImgBG;
	Image*						m_pImgProgressBG[3];
	Image*						m_pImgProgressFG;
	Image*						m_pImgFile;
	Image*						m_pImgCancel;
	Image*						m_pImgCancelOver;
	Image*						m_pImgInitMsg;

	CString						m_strInitMsgText;

	ULONGLONG					m_dwTotalSize;

	Color						m_crBG;
	Color						m_crOutline;

	void						SetImgBGPath(CString strFileName);
	void						SetImgInitMsgPath(CString strFileName);
	void						SetImgFilePath(CString strFileName);
	void						SetImgProgressPath(CString strFileNameFG,
													CString strFileNameBGl,
													CString strFileNameBGc,
													CString strFileNameBGr);
	void						SetImgCancelPath(CString strFileName, CString strFileNameOver);

	void						SetInitMsgText(CString strInit)					{ m_strInitMsgText = strInit; }
	ULONGLONG					GetTotalFileSize()								{ return m_dwTotalSize; }

	// font
	WCHAR						m_wszFontName[64];
	REAL						m_nFontHeight;
	FontStyle					m_fontStyle;
	Color						m_crText;

	void						SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);

	// dimension
	CRect						m_rtWnd;
	CRect						m_rtInitMsg;
	CRect						m_rtInitMsgImg;
	CRect						m_rtInitMsgText;
	CSize						m_szInitMsgText;

	// child
	CPtrArray					m_ptrArFileItem;

	BOOL						IsAlreadyFileList(CString strPath);	
	BOOL						CheckFileAttach(CString strPath = _T(""));
	BOOL						FileAddInitialize();
	void						ClearFileItemAll();
	_memosend_file_item*		AllocFileItem(CString strPath, CString strName, ULONGLONG dwFileSize, int serverIndex);
	BOOL						AddFileItem(CString strPath);
	BOOL						AddFileItem(CString strPath, CString strName, ULONGLONG dwFileSize, int serverIndex, _memosend_file_status eStatus = EMEMOSEND_READY);
	void						Delete(_memosend_file_item* pFileItem, int nIndex);
	void						DeleteFileList(_memosend_file_item* pFileItem, int nIndex);
	BOOL						DeleteFileItem(_memosend_file_item* pFI);
	//BOOL						DeleteFileItemFromPath(CString strPath);
	BOOL						DeleteFileItemFromIndex(int nIndex);
	BOOL						DeleteFileListItemFromIndex(int nServerIndex);
	//BOOL						DeleteFileItemFromName(CString strName);
	void						RecalcFileItem();
	int							GetFileItemCount()								{ return m_ptrArFileItem.GetCount(); }
	CString						GetFileItemName(int nIdx);
	ULONGLONG					GetFileItemTotalSize(int nIdx);
	ULONGLONG					GetFileItemCurSendSize(int nIdx);
	ULONGLONG					GetFileItemTotalSizeAll();
	ULONGLONG					GetFileItemCurSendSizeAll();

	BOOL						SetFileItemStatus(_memosend_file_item* pFI, int nStatus);
	BOOL						SetFileItemCancel(_memosend_file_item* pFI, BOOL bCancel);

	void						UpdateFileAttachComplete(CString strPath);
	void						UpdateFileAttachProgress(int index, DWORD dwSendLength);
	void						FileSendResultWait(int index);
	void						FileSendResultComplete(int index);

	void SetController(SendMemoController* pController);
	void SetModel(CNoteModel* pModel);
	// scroll
	CScrollBar					m_wndScrollBar;
	CRect						m_rtScrollBar;

	int							m_nScrollPageSize;
	int							m_nScrollOneSize;

	BOOL						ScrollItem(int nDiff);
	void						UpdateScrollInfo();
	void						SetScrollOneSize(int nSize)						{ m_nScrollOneSize = nSize; }
	void						RecalcPostFileItem(_memosend_file_item* pFI, int nOffsetY);

	// tracking
	BOOL						m_bTracking;

protected:
	virtual bool				OnGTWASActor_ResponseDeleteAttachedFile(IGTWASActor *pActor, trid_t trid, GTWASCallErrorCode eErrorCode, bool bResult);

	DECLARE_MESSAGE_MAP()
public:
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDestroy();
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg void OnPaint();
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnMouseHover(UINT nFlags, CPoint point);
	afx_msg void OnMouseLeave();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg BOOL OnMouseWheel(UINT nFlags, short zDelta, CPoint pt);
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg LRESULT OnUmMemoSendFileDrop(WPARAM wParam, LPARAM lParam);
	afx_msg  LRESULT OnInitFileAdd(WPARAM wParam, LPARAM lParam);
	
private:
	void _Draw();
	void _DrawBackground(Graphics* pGraphics, CRect *pRcPS);
	void _DrawNoFile(Graphics* pGraphics, CRect *pRcPS);
	void _DrawFileItem(Graphics* pGraphics, CRect *pRcPS, PMEMOSEND_FILE_ITEM pFileItem);
	void _DrawFileName(Graphics* pGraphics, CRect *pRcPS, CString strFileName, CRect *pRcName );
	void _DrawProgressBar(Graphics* pGraphics, double dbProgress, 
							 EMEMOSEND_FILE_STATUS eStatus, CRect *pRcProgress);
	void _DrawFileSize(Graphics* pGraphics, CRect *pRcPS, CString strSize, CRect* pRcSize);
	void _DrawCancelButton(Graphics* pGraphics, CRect *pRcPS, CRect* pRcCancel);

	SendMemoController* m_pSendMemoController;
	CNoteModel* m_pSendMemoModel;

	bool m_bOnceFileCountMsgBox;
	bool m_bOnceFileSizeMsgBox;

	trid_t m_tridDelAttachedFile;
	DELETE_ATTACH_FILE_INFO		m_DeleteAttachFileInfo;

	BOOL m_bEnbleCancel;
};
